condition(1).name='sex';
condition(2).name='positive';
condition(3).name='negative';
condition(4).name='neutral';

roi_average_obj(1).name = 'sex';
roi_average_obj(2).name = 'positive';
roi_average_obj(3).name = 'negative';
roi_average_obj(4).name = 'neutral'; 

clear roi_average_obj

%Get ISC for every ROI for every condition seperately. Mask with the
%main effect ROI (interaction, stimulus type or relationship status) you want to investigate

for k=1:length(condition)
    clear input_files input_files_list2 tmap_obj tmap_obj_thresh
    input_files = dir(fullfile(pwd,'secondlevel','input_data',condition(k).name));
    input_files = input_files(~[input_files.isdir]');
    input_files_list = cell(size(input_files,1),1);

    for i = 1:size(input_files,1)
        input_files_list{i} = fullfile(input_files(i).folder,input_files(i).name);
    end

    input_files_list2 = cell(34,1);
    for j = 1:34
        if j < 18
            input_files_list2{j}=input_files_list{j};
        elseif j > 17
            input_files_list2{j}=input_files_list{j+561};
        end
    end



    fmri_dat = fmri_data(input_files_list2);

    %choose for which effect you want to extract the ROIs
    %tmap = fullfile(pwd,'secondlevel','results_partner_vs_non-partner','two-way_anova_2000_perm','main_effect_relationship','snpmT+.img');
    %tmap = fullfile(pwd,'secondlevel','results_partner_vs_non-partner','two-way_anova_2000_perm','main_effect_condition','snpmT+.img');
    tmap = fullfile(pwd,'secondlevel','results_partner_vs_non-partner','two-way_anova_2000_perm','interaction_relationship_condition','snpmT+.img');
    
    tmap_obj = statistic_image(tmap);
    tmap_obj_thresh = threshold(tmap_obj,[14.20 max(tmap_obj.dat)],'raw-between');

    %write(tmap_obj_thresh,'thresh','fname',fullfile(pwd,'secondlevel','results_partner_vs_non-partner','test2.nii'));

    tmap_obj_thresh_bin = tmap_obj_thresh;
    tmap_obj_thresh_bin.dat(tmap_obj_thresh.sig) = 1; % binarize
    tmap_obj_thresh_bin.dat(~tmap_obj_thresh.sig) = 0; % binarize
    
    write(tmap_obj_thresh_bin,'thresh','fname',fullfile(pwd,'secondlevel','results_partner_vs_non-partner','test.nii'));

    region_obj = region(tmap_obj_thresh_bin);

    [region_obj,~,r_table] = table(region_obj);

    roi_average_obj(k).roi = extract_data(region_obj,fmri_dat);

end