%% Analysing events files
clear all close all 
%setting parameters
nsubj=34;
nquest = 15;
ncond = 6;

%Define directories for input 
rootdir = pwd;
BIDSdir = fullfile(rootdir,'BIDS');
outputdir = fullfile(rootdir,'firstlevel','model_1_basic');
matlabpath = path;
codedir = fullfile(rootdir,'code');

eventslist = dir(fullfile(BIDSdir,'sub-*','func','*events.tsv'));    
eventssubjs = cell(nsubj,1);
for event = 1:nsubj
    eventssubjs{event,1} = fullfile(eventslist(event).folder,eventslist(event).name);
end


% summarize all answers to the questions per question and condition
quest_names = ["bedroefd","opgewekt",'teneergeslagen','ontspannen','angstig','enthousiast','alert','vol_inspiratie','gespannen','tevreden','vastberaden','bang','seksueel_opgewonden','geil','seksueel_verlangen'];

for h = 1:nquest
    summary_quest(h).quest = quest_names(h);
    summary_quest(h).Table = zeros(ncond,nsubj);
end    
for k = 1:nsubj
          eventsfile = eventssubjs{k};
          disp(['loading events in file ' eventsfile]);
          T=readtable(eventsfile,'filetype','delimitedtext');
          T_sorted = T;
          %make sure all conditions are in the same order for every
          %subject: neutral, negative, neutral, positive, neutral, sex
          for j = 1:ncond;
              cond_name = T.trial_type(j);
              cond_name = string(cond_name);
              if cond_name == 'negative'
                  T_sorted(2,:) = T(j,:);
              elseif cond_name == 'positive'
                  T_sorted(4,:) = T(j,:);
              elseif cond_name == 'sex'
                  T_sorted(6,:) = T(j,:);
              end
          end            
    
         get_values_bedroefd = T_sorted.bedroefd(:,1);
         summary_quest(1).Table(:,k) = get_values_bedroefd;
         get_values_opgewekt = T_sorted.opgewekt(:,1);
         summary_quest(2).Table(:,k) = get_values_opgewekt;
         get_values_teneergeslagen = T_sorted.teneergeslagen(:,1);
         summary_quest(3).Table(:,k) = get_values_teneergeslagen;
         get_values_ontspannen = T_sorted.ontspannen(:,1);
         summary_quest(4).Table(:,k) = get_values_ontspannen;
         get_values_angstig = T_sorted.angstig(:,1);
         summary_quest(5).Table(:,k) = get_values_bedroefd;
         get_values_enthousiast = T_sorted.enthousiast(:,1);
         summary_quest(6).Table(:,k) = get_values_enthousiast;
         get_values_alert = T_sorted.alert(:,1);
         summary_quest(7).Table(:,k) = get_values_alert;
         get_values_vol_inspiratie = T_sorted.vol_inspiratie(:,1);
         summary_quest(8).Table(:,k) = get_values_vol_inspiratie;
         get_values_gespannen = T_sorted.gespannen(:,1);
         summary_quest(9).Table(:,k) = get_values_gespannen;
         get_values_tevreden = T_sorted.tevreden(:,1);
         summary_quest(10).Table(:,k) = get_values_tevreden;
         get_values_vastberaden = T_sorted.vastberaden(:,1);
         summary_quest(11).Table(:,k) = get_values_vastberaden;
         get_values_bang = T_sorted.bang(:,1);
         summary_quest(12).Table(:,k) = get_values_bang;
         get_values_seksueel_opgewonden = T_sorted.seksueel_opgewonden(:,1);
         summary_quest(13).Table(:,k) = get_values_seksueel_opgewonden;
         get_values_geil = T_sorted.geil(:,1);
         summary_quest(14).Table(:,k) = get_values_geil;
         get_values_seksueel_verlangen = T_sorted.seksueel_verlangen(:,1);
         summary_quest(15).Table(:,k) = get_values_seksueel_verlangen;
        
end

%% Plotting results
clear avg_data_neutral

avg_data_neutral = zeros(15,34);

for quest = 1:nquest
    avg_data_neutral(quest,:) = (summary_quest(quest).Table(1,:) + summary_quest(quest).Table(3,:) + summary_quest(quest).Table(5,:))/3;
end

figure
boxplot([summary_quest(1).Table(6,:)', summary_quest(2).Table(6,:)', summary_quest(3).Table(6,:)', summary_quest(4).Table(6,:)', summary_quest(5).Table(6,:)', summary_quest(6).Table(6,:),summary_quest(7).Table(6,:)', summary_quest(8).Table(6,:)',summary_quest(9).Table(6,:)',summary_quest(10).Table(6,:)',summary_quest(11).Table(6,:)',summary_quest(12).Table(6,:)',summary_quest(13).Table(6,:)',summary_quest(14).Table(6,:)',summary_quest(15).Table(6,:)'],'Labels',{'bedroefd','opgewekt','teneergeslagen','ontspannen','angstig','enthousiast','alert','vol_inspiratie','gespannen','tevreden','vastberaden','bang','seksueel_opgewonden','geil','seksueel_verlangen'} )
title('Sexual Stimulus')
xlabel('Question')
ylabel('Score')

figure
boxplot([summary_quest(1).Table(4,:), summary_quest(2).Table(4,:), summary_quest(3).Table(4,:), summary_quest(4).Table(4,:), summary_quest(5).Table(4,:), summary_quest(6).Table(4,:),summary_quest(7).Table(4,:), summary_quest(8).Table(4,:),summary_quest(9).Table(4,:),summary_quest(10).Table(4,:),summary_quest(11).Table(4,:),summary_quest(12).Table(4,:),summary_quest(13).Table(4,:),summary_quest(14).Table(4,:),summary_quest(15).Table(4,:)],'Labels',{'bedroefd','opgewekt','teneergeslagen','ontspannen','angstig','enthousiast','alert','vol_inspiratie','gespannen','tevreden','vastberaden','bang','seksueel_opgewonden','geil','seksueel_verlangen'} )
title('Positive Stimulus')
xlabel('Question')
ylabel('Score')

figure
boxplot([summary_quest(1).Table(2,:), summary_quest(2).Table(2,:), summary_quest(3).Table(2,:), summary_quest(4).Table(2,:), summary_quest(5).Table(2,:), summary_quest(6).Table(2,:),summary_quest(7).Table(2,:), summary_quest(8).Table(2,:),summary_quest(9).Table(2,:),summary_quest(10).Table(2,:),summary_quest(11).Table(2,:),summary_quest(12).Table(2,:),summary_quest(13).Table(2,:),summary_quest(14).Table(2,:),summary_quest(15).Table(2,:)],'Labels',{'bedroefd','opgewekt','teneergeslagen','ontspannen','angstig','enthousiast','alert','vol_inspiratie','gespannen','tevreden','vastberaden','bang','seksueel_opgewonden','geil','seksueel_verlangen'} )
title('Negative Stimulus')
xlabel('Question')
ylabel('Score')

figure
boxplot([avg_data_neutral(1,:), avg_data_neutral(2,:), avg_data_neutral(3,:), avg_data_neutral(4,:), avg_data_neutral(5,:), avg_data_neutral(6,:),avg_data_neutral(7,:), avg_data_neutral(8,:),avg_data_neutral(9,:),avg_data_neutral(10,:),avg_data_neutral(11,:),avg_data_neutral(12,:),avg_data_neutral(13,:),avg_data_neutral(14,:),avg_data_neutral(15,:)],'Labels',{'bedroefd','opgewekt','teneergeslagen','ontspannen','angstig','enthousiast','alert','vol_inspiratie','gespannen','tevreden','vastberaden','bang','seksueel_opgewonden','geil','seksueel_verlangen'} )
title('Neutral Stimulus')
xlabel('Question')
ylabel('Score')